#!/usr/bin/python3

import subprocess, sys
from os import chdir
from os.path import expanduser

homedir = expanduser("~")
bundle = "lp:~ce-hyperscale/+junk/demobundle"
mysql = "lp:~ce-hyperscale/charms/precise/mysql/arm64-trusty"
jujugui = "lp:~ce-hyperscale/charms/precise/juju-gui/arm64-trusty"
mediawiki = "lp:~ce-hyperscale/charms/precise/mediawiki/arm64-trusty"
memcached = "lp:~ce-hyperscale/charms/precise/memcached/arm64-trusty"
haproxy = "lp:~ce-hyperscale/charms/precise/haproxy/arm64-trusty"
wordpress = "lp:~ce-hyperscale/charms/precise/wordpress/arm64-trusty"
ganglia = "lp:~ce-hyperscale/charms/precise/ganglia/arm64-trusty"
ganglianode = "lp:~ce-hyperscale/charms/precise/ganglia-node/arm64-trusty"
mediawikicontent = "lp:~ce-hyperscale/charms/precise/mediawiki-content/arm64-trusty"
owncloud = "lp:~ce-hyperscale/charms/precise/owncloud/arm64-trusty"
sugarcrm = "lp:~ce-hyperscale/charms/precise/sugarcrm/arm64-trusty"

def main():
    print("Prepping your Home Directory")
#Uncomment this line at final release
    chdir(homedir)

#Branch all of our custom charms
    subprocess.call(["bzr", "branch", bundle, "hyperdemo/"])
    subprocess.call(["mkdir", "-p", "hyperdemo/trusty"])
    subprocess.call(["bzr", "export", "hyperdemo/trusty/mysql-311", mysql])
    subprocess.call(["bzr", "export", "hyperdemo/trusty/juju-gui-110", jujugui])
    subprocess.call(["bzr", "export", "hyperdemo/trusty/mediawiki-90", mediawiki])
    subprocess.call(["bzr", "export", "hyperdemo/trusty/memcached-28", memcached])
    subprocess.call(["bzr", "export", "hyperdemo/trusty/haproxy-28", haproxy])
    subprocess.call(["bzr", "export", "hyperdemo/trusty/wordpress-93", wordpress])
    subprocess.call(["bzr", "export", "hyperdemo/trusty/ganglia-53", ganglia])
    subprocess.call(["bzr", "export", "hyperdemo/trusty/ganglia-node-28", ganglianode])
    subprocess.call(["bzr", "export", "hyperdemo/trusty/mediawiki-content-0", mediawikicontent])
    subprocess.call(["bzr", "export", "hyperdemo/trusty/owncloud-8", owncloud])
    subprocess.call(["bzr", "export", "hyperdemo/trusty/sugarcrm-0", sugarcrm])

#Kick off juju-gui
    print("Installing juju-gui")
    subprocess.call(["juju", "set-env", "default-series=trusty"])
    subprocess.call(["juju", "deploy", "--repository=hyperdemo",\
            "local:trusty/juju-gui"])

    print("Done, Please allow juju-gui time to deploy before launching the bundle")
    print("Deploy the bundle by issuing the following: \n juju deployer\
 -c ~/hyperdemo/bundles.yaml")

if __name__ == "__main__":
    sys.exit(main())
